<template>
  <div>
    <component-header v-bind:titleHeader="title" v-on:changeTitleEvent="handleChangeTitle"></component-header>
    <component-list-user v-bind:listUser="listUser" v-on:deleteUserEvent="handDeleteUser"></component-list-user>
    <demo-slot>
      <div class="app-slot">
        <h2 class='slot' >Title Slot </h2>
        <p>Content Slot </p>
      </div>
    </demo-slot>
    <component-table></component-table>
    <componentList></componentList><hr>
    <component-product></component-product><hr>
    <component-mixin></component-mixin>
    <component-plugin></component-plugin>
    <component-footer v-bind:title="title"></component-footer>
  </div>
</template>

<script>

import ComponentHeader from './components/ComponentHeader.vue';
import ComponentFooter from './components/ComponentFooter.vue';
import ComponentListUser from './components/ComponentListUser.vue';
import ComponentList from './components/ComponentList.vue';
import ComponentTable from './components/ComponentTable.vue';
import ComponentProduct from './components/ComponentProduct.vue';
import ComponentMixin from './components/ComponentMixin.vue';
import DemoSlot from './DemoSlot.vue';

export default {
  name: 'app',
  data: function() {
    return {
      title: "Hello Cường",
      listUser: [
        {id:1, name : 'Ngô Thế Cường 1', age: '24', address: 'Me Linh, Ha Noi', active: true},
        {id:2, name : 'Ngô Thế Cường 2', age: '24', address: 'Me Linh, Ha Noi', active: false},
        {id:3, name : 'Ngô Thế Cường 3', age: '24', address: 'Me Linh, Ha Noi', active: true},
        {id:4, name : 'Ngô Thế Cường 4', age: '24', address: 'Me Linh, Ha Noi', active: true},
      ],
      cardTitle : "Demo slot"
    }
  },
  components: {
    ComponentHeader,
    ComponentFooter,
    ComponentListUser,
    DemoSlot,
    ComponentList,
    ComponentTable,
    ComponentProduct,
    ComponentMixin
  },
  methods: {
    handleChangeTitle() {
      this.title = 'Title sau khi thay đổi';
      console.log(' Event duoc goi');
    },
    handDeleteUser(data) {
      this.listUser.forEach((user, location) => {
        console.log(user.id, location, data.id);
         if(user.id === data.id) {
            this.listUser.splice(location, 1);
         }
      });
      console.log('handDeleteUser trong file app', data);
    }
  },
};
</script>